"""Custom FastAPI Responses."""

from fastapi.responses import StreamingResponse
from typing import AsyncIterable

from jax.apiutils.fastapi.schemas.rest import ServerSideEvent


class ServerSideEventResponse(StreamingResponse):
    """Schema for server side event responses."""

    def __init__(self, iterator: AsyncIterable):
        super().__init__(
            content=(ServerSideEvent(data=item) async for item in iterator),
            media_type="text/event-stream",
        )
